type aig_and = {
  lhs : int;
  mutable rhs0 : int;
  mutable rhs1 : int;
  mutable in_use : bool;
  mutable simplified : bool;
}
val and_as_string : aig_and -> string
type aig_symbol = {
  mutable lit : int;
  mutable next : int;
  reset : int;
  size : int;
  lits : int list;
  name : string;
  mutable used : bool;
  mutable removed : bool
}
val latch_as_string : aig_symbol -> string
type aig_symbol_list = aig_symbol list
type aiger = {
  max_var : int;
  inputs : aig_symbol_list;
  latches : aig_symbol_list;
  outputs : aig_symbol_list;
  bad : aig_symbol_list;
  constraints : aig_symbol_list;
  justice : aig_symbol_list;
  fairness : aig_symbol_list;
  ands : aig_and list;
  comments : string list;
}
val aiger_stat : aiger -> string
val lit2var : int -> int
val neg : int -> int
