open Logic_interface

exception No_path_in_tr

val extend_one_bound : int -> clause list
val get_next_clauses_from_unsat_core : clause list -> int -> clause list

val get_new_next_segments : UnsatCore.unsat_core list -> bool
val clear_saved_assumptions : unit -> unit
val add_used_assumptions : term list -> unit

val print_transition_relation_size : unit -> unit
val clear_current_rel : int -> unit
val get_negative_assumptions : unit -> term list

(* get all the selected literals from the model *)
val get_model_literals : context -> term list

(* return [] or [lemma] *)
val get_lemma_by_uc : UnsatCore.unsat_core -> clause list

val set_full_rel : clause list -> unit
val get_cone_symb : unit -> clause list

val get_reduced_problem : unit -> clause list
val get_aig_pass_cone : unit -> clause list
val get_aig_restricted_cone : int -> clause list

val get_restricted_cone : int -> clause list
val max_depth_reached : int -> bool
