open Logic_interface

(*------- out models for resolution ---------------*)

let sat_out_active_clauses ~all_clauses ~filtered_out =
  
  (* Filter clause database for active clauses *)
  let active_clauses =
    context_fold
      all_clauses
      (fun c a ->
	if
	  Clause.get_ps_in_active c
	then
	  c :: a
	else
	  a)
      []
  in
  
  (* Start saturation output *)
  Format.printf "@\n%% SZS output start Saturation@\n@.";
  let all_clauses_list = filtered_out@active_clauses in

  (* Saturation output *)
  Format.printf
    "%a@."
    TstpProof.pp_clauses_with_clausification
    all_clauses_list;
  
  (* End saturation output *)
  Format.printf "%% SZS output end Saturation@\n@."

let out_res_model ~all_clauses ~filtered_out =
  sat_out_active_clauses  ~all_clauses ~filtered_out
