open Lib
open Logic_interface

exception PS_loop_time_out of int
 

type prover_functions = {
    mutable inst_lazy_loop_body : (int ref -> int ref -> unit) param;
    mutable inst_add_clause : (clause -> unit) param;
    mutable inst_get_all_input_clauses : (unit -> clause list) param;
    mutable inst_clear_all : (unit -> unit) param;
    mutable res_discount_loop_exchange : (unit -> unit) param;
    mutable res_add_clause : (clause -> unit) param;
    mutable res_get_all_input_clauses : (unit -> clause list) param;
    mutable res_simplified_input : context param;
    mutable res_clear_all : (unit -> unit) param
  }

val create_provers : 
    inst_name_param:string Lib.param -> res_name_param:string Lib.param -> clause list -> prover_functions

val create_provers_current_options : clause list -> prover_functions

(* can raise: exception PS_loop_time_out of int *)
val full_loop : prover_functions ->  time_limit:float Lib.param -> clause list ref -> unit

val provers_clear_and_remove_all : unit -> unit
val provers_clear_and_remove_top : unit -> unit

val clear_all_provers : prover_functions -> unit




val simplify_input : prover_functions -> clause list -> clause list

